<?php
/**
 * @package   astecv3
 * @name      c_pedido_venda_tools
 * @version   3.0.00
 * @copyright 2017
 * @link      http://www.admservice.com.br/
 * @author    Marcio Sergio da Silva<marcio.sergio@admservice.com.br>
 * @date      28/06/2017
 */

$dir = dirname(__FILE__);
include_once($dir . "/../../class/ped/c_ordem_compra.php");
include_once($dir . "/../../class/est/c_produto.php");
include_once($dir . "/../../class/est/c_produto_estoque.php");
include_once($dir . "/../../bib/c_date.php");
include_once($dir . "/../../bib/c_tools.php");

//Class 
Class c_atendimentoTools extends c_atendimento {

   


/**
* METODOS DE SETS E GETS
*/

//############### FIM SETS E GETS ###############


/**
 * <b> Rotina que gera novo pedido e inclui itens selecionados no pedido </b>
 * @name incluiItensPedidoControle
 * @param VARCHAR condPgto
 * @param int total
 * @return Matriz com as datas de vencimento e valores de cada parcela.
 */
public function excluiServicoAtendimento($cc, $idAtendimento, $idItem, $tipoMsg=null, $situacao ){
    try{
        $tipoMsg = "sucesso";
        $msg ="";

        $this->setId($idAtendimento);
        $this->setIdServico($idItem);        
        
        $msg = $this->excluiServicosItemAtendimento();
        
        // atualiza total
        $this->setIdAtendimentoServico($idAtendimento);
        $totalServicos = $this->select_servicos_total();
        $this->setValorServicos($totalServicos, 'B');
        //$this->setCliente($cliente);
        $this->setId($idAtendimento);
        $this->setSituacao($situacao);

        $this->alteraServicoTotalAtendimento();
        
        return $msg;
    } catch (Error $e) {
        throw new Exception($e->getMessage()."Item não excluido " );

    } catch (Exception $e) {
        throw new Exception($e->getMessage(). "Item não excluido " );

    }
                    
}
public function alteraServicoAtendimentoControle($idAtendimento, $arrServico, $situacao){
    try{
        $m_item = explode("|", $arrServico);

        $msg = "";
        $this->setIdAtendimentoPecas($idAtendimento);
        $this->setCodProduto($m_item[0]);      

        $this->setDescricaoServico($m_item[1]);
        $this->setUnidadeServico($m_item[2]);
        $this->setQuantidadeServico($m_item[3]);
        $this->setVlrUnitarioServico($m_item[4]);
        $totalServico = (($this->getQuantidadeServico('B') * $this->getVlrUnitarioServico('B')));
        $this->setTotalServico($totalServico, true);

        // $arrServicoAtendimento = $this->select_atendimento_item_id_servico();
        
        $this->setIdServico($m_item[0]);
        
        $this->alteraServicos();
        
        $this->setId($idAtendimento);
        $this->setIdAtendimentoServico($idAtendimento);
        $this->setSituacao($situacao);
        $totalServicos = $this->select_servicos_total();
        $this->setValorServicos($totalServicos, true);

        $this->alteraServicoTotalAtendimento();
        $tipoMsg = "sucesso";

        return $msg;
    } catch (Error $e) {
        throw new Exception($e->getMessage()."Item não alterado " );

    } catch (Exception $e) {
        throw new Exception($e->getMessage(). "Item não alterado " );

    }
}  
public function incluiServicoAtendimentoControle($cc, &$idAtendimento, $itemId, $itemValor, $itensQtde, $tipoMsg=null, $cliente, $situacao, $catTipoId){
    try{
        if (empty($idAtendimento)){
            $this->setCliente($cliente);
            if($this->getDataAberturaEnd() == ''){
                $this->setDataAberturaEnd(date("d/m/Y"));
            }
            if($this->getDataFechamentoEnd() == ''){
                $this->setDataFechamentoEnd(date("d/m/Y"));
            }
            $this->setCentroCusto($cc);
            $this->setCatTipoId($catTipoId);
            $this->setSituacao($situacao);
            $idAtendimento = $this->incluiAtendimento();
        }

        $msg = "";
        $this->setIdAtendimentoServico($idAtendimento);
        $this->setCatServicoId($itemId);

        $arrServicoAtendimento = $this->select_atendimento_item_id_servico();
        if (is_array($arrServicoAtendimento)):
            $this->setIdServico($arrServicoAtendimento[0]['ID']);
            $quantServicoAtendimento = $arrServicoAtendimento[0]['QUANTIDADE']; // quant já cadastrada
            $itensQtde += $quantServicoAtendimento;
        endif;

        $arrServicos = $this->select_atendimento_cat_servico();

        $this->setDescricaoServico($arrServicos[0]['DESCRICAO']);
        $this->setUnidadeServico($arrServicos[0]['UNIDADE']);

        $this->setQuantidadeServico(str_replace('.', ',', $itensQtde));

        $itemValor = $itemValor;

        $this->setVlrUnitarioServico(str_replace('.', ',', $itemValor));
        $this->setTotalServico(str_replace('.', ',', ($itensQtde * $itemValor)));


        if (is_array($arrServicoAtendimento)):
            $this->alteraServicos();
        else:            
            $this->incluiServicos();
        endif;
        // atualiza total
        $totalServicos = $this->select_servicos_total();
        $this->setValorServicos($totalServicos, 'B');
        //$this->setCliente($cliente);
        $this->setId($idAtendimento);
        $this->setSituacao($situacao);

        $this->alteraServicoTotalAtendimento();
        $tipoMsg = "sucesso";

        return $msg;
    } catch (Error $e) {
        throw new Exception($e->getMessage()."Item não cadastrado " );

    } catch (Exception $e) {
        throw new Exception($e->getMessage(). "Item não cadastrado " );

    }
                    
}



/**
 * <b> Rotina que gera novo pedido e inclui itens selecionados no pedido </b>
 * @name incluiItensPedidoControle
 * @param VARCHAR condPgto
 * @param int total
 * @return Matriz com as datas de vencimento e valores de cada parcela.
 */
public function excluiPecasAtendimento($cc, $idAtendimento, $idItem, $tipoMsg=null, $situacao ){
    try{
        $tipoMsg = "sucesso";
        $msg ="";

        $this->setId($idAtendimento);
        $this->setIdPecas($idItem);        

        $consulta = new c_banco;
        $consulta->setTab("CAT_AT_PECAS");
        $descontoPeca = $consulta->getField("DESCONTO", "ID=".$this->getIdPecas());
        $consulta->close_connection();
        
        $msg = $this->excluiPecasItemAtendimento();

        $consulta = new c_banco;
        $consulta->setTab("CAT_ATENDIMENTO");
        $vlrDesconto = $consulta->getField("VALORDESCONTO", "ID=".$this->getId());
        $consulta->close_connection();

        $vlrDesconto -= $descontoPeca;

        $this->updateField("VALORDESCONTO", $vlrDesconto, "CAT_ATENDIMENTO");
        
        // atualiza total
        $this->setIdAtendimentoPecas($idAtendimento);
        $totalPecas = $this->select_pecas_total();
        $this->setValorPecas($totalPecas, 'B');
        $this->setId($idAtendimento);
        $this->setSituacao($situacao);

        $this->alteraPecasTotalAtendimento();
        
        return $msg;
    } catch (Error $e) {
        throw new Exception($e->getMessage()."Item não excluido " );

    } catch (Exception $e) {
        throw new Exception($e->getMessage(). "Item não excluido " );

    }
                    
}
public function alteraPecasAtendimentoControle($idAtendimento, $arrPeca, $situacao){
    try{
        $m_item = explode("|", $arrPeca);

        $msg = "";
        $this->setIdAtendimentoPecas($idAtendimento);
        $this->setCodProdutoNota($m_item[1]);      

        $this->setDescricaoPecas($m_item[2]);
        $this->setUnidadePecas($m_item[3]);
        $this->setQuantidadePecas($m_item[4]);
        $this->setVlrUnitarioPecas($m_item[5]);
        $this->setDescontoPecas($m_item[7]);
        $this->setPercDescontoPecas($m_item[6]);
        $totalPeca = ($this->getQuantidadePecas('B') * $this->getVlrUnitarioPecas('B'));
        $this->setTotalPecas($totalPeca, true);

        // $arrPecasAtendimento = $this->select_atendimento_item_id_pecas();
        $this->setIdPecas($m_item[0]);
        
        $msg = $this->alteraPecas();
        
        // atualiza total
        $totalPecas = $this->select_pecas_total();
        $this->setValorPecas($totalPecas, 'B');
        $this->setId($idAtendimento);
        $this->setSituacao($situacao);

        $this->setIdAtendimentoPecas($idAtendimento);
        
        $vlrDesconto = $this->select_desconto_pecas_total();

        $this->updateField("VALORDESCONTO", $vlrDesconto, "CAT_ATENDIMENTO");
        $this->alteraPecasTotalAtendimento();

        if ($msg == '')
            $tipoMsg = "sucesso";
        else    
            $tipoMsg = "erro";

        return $msg;
    } catch (Error $e) {
        throw new Exception($e->getMessage()."Item não alterado " );

    } catch (Exception $e) {
        throw new Exception($e->getMessage(). "Item não alterado " );

    }
                    
}

public function incluiPecasAtendimentoControle($cc, &$idAtendimento, $itemId, $itemValor, $itensQtde, $tipoMsg=null, $cliente, $situacao, $catTipoId, $descontoPecas, $percDescontoPecas, $descProduto, $uniProduto, $codProdutoNota=null){
    try{
        if (empty($idAtendimento)){
            $this->setCliente($cliente);
            if($this->getDataAberturaEnd() == ''){
                $this->setDataAberturaEnd(date("d/m/Y"));
            }
            $this->setCentroCusto($cc);
            $this->setCatTipoId($catTipoId);
            $this->setSituacao($situacao);
            $idAtendimento = $this->incluiAtendimento();
        }

        $msg = "";
        $this->setIdAtendimentoPecas($idAtendimento);
        $this->setCodProduto($itemId);
        $this->setCodProdutoNota($codProdutoNota);

        // $arrPecasAtendimento = $this->select_atendimento_item_id_pecas();
        // if (is_array($arrPecasAtendimento)):
        //     $this->setIdPecas($arrPecasAtendimento[0]['ID']);
        //     $quantPecasAtendimento = $arrPecasAtendimento[0]['QUANTIDADE']; // quant já cadastrada
        //     $itensQtde += $quantPecasAtendimento;
        // endif;


        // $arrItemEstoque = $this->select_atendimento_pecas_produto();

        // $this->setDescricaoPecas($arrItemEstoque[0]['DESCRICAO']);
        // $this->setUnidadePecas($arrItemEstoque[0]['UNIDADE']);

        $this->setDescricaoPecas($descProduto);
        $this->setUnidadePecas($uniProduto);
        $this->setQuantidadePecas($itensQtde, true);

        // $consulta = new c_banco;
        // $consulta->setTab("CAT_TIPO");
        // $tipoCobPreco = $consulta->getField("COBTIPOPRECO", "ID=".$catTipoId);
        // $consulta->close_connection();

       
        $itemValor = $itemValor;

        $this->setVlrUnitarioPecas($itemValor, true);
        $this->setDescontoPecas($descontoPecas, true);
        $this->setPercDescontoPecas($percDescontoPecas, true);
        // $this->setTotalPecas(str_replace('.', ',', (($itensQtde * $itemValor)-$descontoPecas)));
        $this->setTotalPecas($itensQtde * $itemValor, true);


        // if (is_array($arrPecasAtendimento)):
        //     $this->alteraPecas();
        // else:            
        $this->incluiPecas();
        // endif;
        
        // atualiza total
        $totalPecas = $this->select_pecas_total();
        $this->setValorPecas($totalPecas, 'B');
        $this->setId($idAtendimento);
        $this->setSituacao($situacao);

        if (!is_array($arrPecasAtendimento)):
            $consulta = new c_banco;
            $consulta->setTab("CAT_ATENDIMENTO");
            $vlrDesconto = $consulta->getField("VALORDESCONTO", "ID=".$this->getId());
            $consulta->close_connection();

            $vlrDesconto += $descontoPecas;

            $this->updateField("VALORDESCONTO", $vlrDesconto, "CAT_ATENDIMENTO");
        endif;
        $this->alteraPecasTotalAtendimento();
        $tipoMsg = "sucesso";

        return $msg;
    } catch (Error $e) {
        throw new Exception($e->getMessage()."Item não cadastrado " );

    } catch (Exception $e) {
        throw new Exception($e->getMessage(). "Item não cadastrado " );

    }
                    
}
public function recalcularDescontoPecas($idAtendimento, $descontoAtendimento){
    try{
        $this->setId($idAtendimento);
        $arrPecasAtendimento = $this->select_pecas_atendimento();


    }catch(Error $e){
        throw new Exception($e->getMessage()."Problemas ao fazer o recalculo do Desconto." );
    }
}

}	//	END OF THE CLASS
?>
