<?php
/**
 * @package   astecv3
 * @name      c_inventario_tools
 * @version   3.0.00
 * @copyright 2021
 * @link      http://www.admservice.com.br/
 * @author   Tony
 * @date  17/03/2021
 */

$dir = dirname(__FILE__);
include_once($dir . "/../../bib/c_date.php");
include_once($dir . "/../../bib/c_tools.php");
include_once($dir . "/../../class/est/c_inventario.php");
require_once($dir."/../../class/est/c_nota_fiscal.php");
require_once($dir."/../../class/est/c_nota_fiscal_produto.php");
require_once($dir . "/../../class/fin/c_lancamento.php");
require_once($dir . "/../../class/est/c_cond_pgto.php");


//Class c_inventario_tools
Class c_inventario_tools extends c_inventario {

   
    function insereNfInventario($arrInventario, $idInventario, $tipoNf, $centroCusto) {
        $objEstProduto = new c_produto_estoque();
        $classNF = new c_nota_fiscal();
        $classNFProduto = new c_nota_fiscal_produto();
        
        $parItens = explode("|", $arrInventario);
    
        $parametros = new c_banco;
        $parametros->setTab("EST_PARAMETRO");
        $controlaEstoque = $parametros->getField("CONTROLAESTOQUE", "FILIAL=".$centroCusto);
        $clientePadrao = $parametros->getField("CLIENTEPADRAO", "FILIAL=".$centroCusto);
        $parametros->close_connection();                      
        
       // $qtde = $quant;//(int) $quant;
        /*
        if($tipoNf == '1'){
            $this->m_modelo = '1';
            $this->m_serieDocto = 'SAI';
        }else{
            $this->m_modelo = '0';
            $this->m_serieDocto = 'ENT';
        } */

      /*  $vlrVenda = str_replace(',', '.', $this->valorVenda);
        $quantidade = str_replace(',', '.', $qtde);
        $totalProd = ($quantidade * $vlrVenda); */

       // $totalFormatado = number_format((double) $parItens[0], 2, ',', '.');

       //EST_NOTA_FISCAL
        $classNF->setModelo($tipoNf);
        $classNF->setSerie('INV');
        $classNF->setNumero($idInventario);
        $classNF->setPessoa(1);
        $classNF->setEmissao(date('d/m/Y H:i:s'));
        //nat operacao
        $classNF->setIdNatop(99);
        $classNF->setNatOperacao('INVENTARIO');
        $classNF->setTipo($tipoNf); // 0=Entrada; 1=Saída; 
        $classNF->setSituacao('B');
        $classNF->setFormaPgto('0');
        $classNF->setDataSaidaEntrada(date('d/m/Y H:i:s'));
        $classNF->setFinalidadeEmissao(9);
        $classNF->setTransportador(0);
        $classNF->setCentroCusto($centroCusto);
        $classNF->setGenero("INV");
        $classNF->setOrigem('INV');
        $classNF->setDoc(0);
        $classNF->setModFrete(0); // verificar outras opção de frete no XML
        $classNF->setTotalnf($parItens[0]);
        //$classNF->setObs($this->m_obsNf);	
        // insere nf
        $lastNF = $classNF->incluiNotaFiscal();

        //$classNF->setId($lastNF);
        //$classNF->setNumero($lastNF);
        //$classNF->alteraNfNumero();
        
       //EST_NOTA_FISCAL_ESTOQUE
        
        for($i= 1; $i < count($parItens); $i++){
            $item = explode("*", $parItens[$i]);

            $classNFProduto->setIdNf($lastNF);
            $classNFProduto->setCodProduto($item[1]);
            $classNFProduto->setDescricao($item[2]);
            $classNFProduto->setUnidade($item[3]);
            $classNFProduto->setQuant($item[4]);
            $classNFProduto->setUnitario($item[5]);
            $classNFProduto->setTotal($item[6]);
            $classNFProduto->setOrigem('0');
            $classNFProduto->setTribIcms('00');
            $classNFProduto->setCfop('9999');
            $classNFProduto->setDataConferencia(date('d-m-Y h:m:s'));
            $classNFProduto->incluiNotaFiscalProduto();

            //quantidade movimentada
            $this->setQuantidade($item[4]);

            $this->alteraInventarioProdutoQtdeMov($item[7],$this->getQuantidade('B') ,$item[0]);
        }
        
        
        // QUANTIDADE PRODUTO_ESTOQUE 
        
        /*$ifControlaEstoque = (($controlaEstoque == 'S') && ($this->uniFracionada == 'N'));
        if ($ifControlaEstoque):
            $objEstProduto = new c_produto_estoque();
            if ($tipoNf == '0'):
                for ($i = 0; $i < $qtde; $i++) {
                    $objEstProduto->setIdNfEntrada($lastNF);
                    $objEstProduto->setCodProduto($this->id_produto);
                    $objEstProduto->setStatus('0');
                    $objEstProduto->setAplicado('0');
                    $objEstProduto->setCentroCusto($this->ccustoOrigem);
                    $objEstProduto->setUserProduto($this->m_userid);
                    $objEstProduto->setLocalizacao('');
                    //$objEstProduto->setNsEntrada($this->getNumSerie());
                    $objEstProduto->setFabLote('');
                    $objEstProduto->setDataFabricacao('');
                    $objEstProduto->setDataValidade('');
                    $objEstProduto->incluiProdutoEstoque();
                }//for
                
            else:
                $objEstProduto->produtoBaixa($this->ccustoOrigem, $this->id_produto, $qtde, $lastNF);
            endif;
        endif; */

        return $lastNF;
        
    }



}	//	END OF THE CLASS
?>
