<?php
/**
 * @package   astecv3
 * @name      c_pedido_venda_nf
 * @version   3.0.00
 * @copyright 2016
 * @link      http://www.admservice.com.br/
 * @author    Marcio Sergio da Silva<marcio.sergio@admservice.com.br>
 * @date      06/12/2016
 */

$dir = dirname(__FILE__);
include_once($dir . "/../../class/ped/c_pedido_venda.php");
include_once($dir . "/../../bib/c_date.php");
include_once($dir . "/../../bib/c_tools.php");

//Class 
Class c_pedidoVendaNf extends c_pedidoVenda {

    //construtor
    function __construct(){
        // Cria uma instancia variaveis de sessao
        c_user::from_array($_SESSION['user_array']);

    }
/**
* METODOS DE SETS E GETS
*/

//############### FIM SETS E GETS ###############


/**
 * <b> Calcaula as parcelas para ser lancadas no financeiro, a primeira parcela o valor é ajusto para fechar com o total da NF </b>
 * @name calculaParcelasNfe
 * @param VARCHAR condPgto
 * @param int total
 * @return Matriz com as datas de vencimento e valores de cada parcela.
 */
public function calculaParcelasNfe($condPgto = NULL, $total = 0){
    //setlocale(LC_MONETARY, 'en_US');
    $descCondPgto = str_replace('DIAS', '', $condPgto);
    $parcelas = explode("/", $condPgto);
    $numParcelas = count($parcelas);
    $totalGeral = $total;
    //$valorParcela = money_format('%i', $totalGeral / $numParcelas);
    //$valorParcela =  str_replace(number_format(($totalGeral / $numParcelas),2),',','');
    $valorParcela =  round($totalGeral / $numParcelas, 2, PHP_ROUND_HALF_DOWN); 
    for ($i = 0; $i < $numParcelas; $i++) {
        $lanc[$i]['PARCELA'] = $i + 1;
        $lanc[$i]['VENCIMENTO'] = date("Y-m-d", strtotime(date("Y-m-d") . "  + ".intval($parcelas[$i])." day"));
        $lanc[$i]['VALOR'] = $valorParcela;
    }
    $lanc[0]['VALOR'] = $valorParcela - (($valorParcela * $numParcelas) - doubleval($totalGeral));
    return $lanc;
}

/**
 * <b> É responsavel por buscar informações da tabela tritutos para calculo dos impostos da NFe </b>
 * <b> os campos NCM e CEST são opcionais </b>
 * @name calculaImpostosNfe
 * @param int natOp
 * @param VARCHAR uf
 * @param CHAR tipoPessoa
 * @param VARCHAR origem 
 * @param VARCHAR tribIcms
 * @param VARCHAR ncm
 * @param VARCHAR cest
 * @return vazio - os campos são calculados e setados dentro da função, não havendo retorno.
 */
public function calculaImpostosNfe($objNfProd = NULL, $natOp = NULL, $uf=NULL, $tipoPessoa=NULL, $centroCusto=NULL){

    $arrTributos =  [];
    $origem=$objNfProd->getOrigem();
    $tribIcms=$objNfProd->getTribIcms();
    $ncm=$objNfProd->getNcm();
    $cest=$objNfProd->getCest();
    //Rodrigo
    // Alíquota de IPI  já tem  $aliqIpi(tab de tributos), mas tem que pegar do produto
        $produto=$objNfProd->getProduto();
        $banco = new c_banco();
        $sql = "select * from est_produto where (codigo=".$produto.")";
        $prod = $banco->exec_sql($sql);
        $aliqIpi=$prod[0]['ALIQIPI'];     
    // ou pegar da NCM (tabela nova)   
        $produto=$objNfProd->getProduto();
        $banco = new c_banco();
        $sql = "select * from est_ncm where (ncm=".$ncm.")";
        $prod = $banco->exec_sql($sql);
        $aliqIpi=$prod[0]['ALIQIPI'];    
        $aliqPisMonofasica=$prod[0]['ALIQPISMONOFASICA'];        // problema de atualização
        $aliqCofinsMonofasica=$prod[0]['ALIQCOFINSMONOFASICA'];  // ???  
    // Dados do Cliente
    $cliente=$objNotaFiscal->getPessoa();
    // Estado do Cliente    
    // Cliente Contrib. ICMS
    // Cliente Cons Final
    // Cliente Regime Especial ST
    // Cliente Regime Especial ST MT
    // Beneficio da ZFM (ICMS, PIS/COFINS e IPI) ???? 
        // BUSCA PARAM DO CLIENTE 
        $banco = new c_banco();
        $sql = "select * from fin_cliente where (cliente=".$cliente.")";
        $cli = $banco->exec_sql($sql);
        $contribuinteICMS=$cli[0]['CONTRIBUINTEICMS'];    
        $consumidorfinal=$cli[0]['CONSUMIDORFINAL'];        
        $regimeespecialST=$cli[0]['REGIMEESPECIALST'];            
        $regimeespecialSTMT=$cli[0]['REGIMEESPECIALSTMT'];
        $aliqRegEspSTMT=$cli[0]['ALIQREGIMEESPECIALSTMT'];
        $ufDestino=$cli[0]['UF']; 
    // Aliq Interestadual (4, 7, 12) [do estado do cliente]
    // Aliq Interna(ST) (17, 17.5, 18) [do estado do cliente]
    // Aliq FCP (1%, 2%) [do estado do cliente]
    // MVA Original e MVA Estado (40, 56.90, 71.78) [do estado do cliente]


    // BUSCA CRT EMPRESA
    $banco = new c_banco();
    //$sql = "select * from amb_empresa where (centrocusto=".$centroCusto.")";
    $sql = "select * from amb_empresa where (centrocusto=".$this->m_empresacentrocusto.")";
    $emp = $banco->exec_sql($sql);
    $crt=$emp[0]['REGIMETRIBUTARIO'];

    $sql  = "SELECT * FROM EST_NAT_OP_TRIBUTO ";
//    $sql .= "WHERE (CENTROCUSTO =".$centroCusto.") AND (IDNATOP =".$natOp.") AND (UF='".$uf."') AND (PESSOA='".$tipoPessoa."') ";
    $sql .= "WHERE (CENTROCUSTO =".$this->m_empresacentrocusto.") AND (IDNATOP =".$natOp.") AND (UF='".$uf."') AND (PESSOA='".$tipoPessoa."') ";
    if (($natOp=='2') and ($crt!='3')){
        if ($origem!='') {
            $sql .= " AND (ORIGEM='".$origem."') ";        
        }
        if ($tribIcms!='') {
            $sql .= " AND (TRIBICMS='".$tribIcms."') ";        
        }
        if ($ncm!='') {
            $sql .= " AND ((NCM='".$ncm."') OR (NCM='')) ";        
        }
        if ($cest!='') {
            $sql .= " AND ((CEST='".$cest."') OR (CEST='')) ";
        }
        $sql .= ' ORDER BY NCM DESC ';
    } else if ($crt=='3') {
        $sql .= " AND (ORIGEM='".$origem."') AND (TRIBICMS='".$tribIcms."') AND ((NCM='".$ncm."') OR (NCM='')) AND ((CEST='".$cest."') OR (CEST=''));";
    } else {    
        $sql .= " AND (ORIGEM='".$origem."');";
    }
    
   // echo strtoupper($sql);
    $banco->exec_sql($sql);
    $banco->close_connection();
    $arrTributos =  $banco->resultado;
    if (isset($arrTributos)):

        // seta aliquotas
        $objNfProd->setCfop($arrTributos[0]['CFOP']);
        $objNfProd->setAliqIcms($arrTributos[0]['ALIQICMS'], true);
        $objNfProd->setPercReducaoBc($arrTributos[0]['PERCREDUCAOBC'], true);
        $objNfProd->setModBc($arrTributos[0]['MODBC']);
        $objNfProd->setPercDiferido($arrTributos[0]['PERCDIFERIDO'], true);
        $objNfProd->setModBcSt($arrTributos[0]['MODBCST']);
        $objNfProd->setPercMvaSt($arrTributos[0]['MVAST'], true);
        $objNfProd->setPercReducaoBcSt($arrTributos[0]['PERCREDUCAOBCST'], true);
        $objNfProd->setAliqIcmsSt($arrTributos[0]['ALIQICMSST'], true);
        $objNfProd->setAliqIpi($arrTributos[0]['ALIQIPI'], true);
        $objNfProd->setInsideIpiBc($arrTributos[0]['INSIDEIPIBC']);
        $objNfProd->setCstPis($arrTributos[0]['CSTPIS']);
        $objNfProd->setAliqPis($arrTributos[0]['ALIQPIS'], true);
        $objNfProd->setCstCofins($arrTributos[0]['CSTCOFINS']);
        $objNfProd->setAliqCofins($arrTributos[0]['ALIQCOFINS'], true);
        $objNfProd->setTribIcms($arrTributos[0]['TRIBICMSSAIDA']);
        //Rodrigo
        //$objNfProd->setMvaOriginal($arrTributos[0]['MVAORIGINAL']); // pegar [MVAST]
        $objNfProd->setMvaAjustada($arrTributos[0]['MVAAJUSTADA']);
        $objNfProd->setAliqFcpSt($arrTributos[0]['ALIQFCPST']);
    // Aliq Interestadual (4, 7, 12) [do estado do cliente]   [ALIQICMS]
    // Aliq Interna(ST) (17, 17.5, 18) [do estado do cliente] [ALIQICMSST]
    // Aliq FCP (1%, 2%) [do estado do cliente]               [ALIQFCPST]
    // MVA Original e MVA Estado (40, 56.90, 71.78) [do estado do cliente]  [MVAST]/[MVAAJUSTADA]

        // inicializa campos , SEM PARAMETRO DE FORMATAÇÃO PARA TRAZER DEFAULT
        $totalProduto = $objNfProd->getTotal('B');
        $descontoProduto = $objNfProd->getDesconto('B');
        $aliqIcms = $objNfProd->getAliqIcms('B');
        $percReducaoBc = $objNfProd->getPercReducaoBc('B');
        $percDiferido = $objNfProd->getPercDiferido('B');
        $mvaSt = $objNfProd->getPercMvaSt('B');
        $percReduacaoBcSt = $objNfProd->getPercReducaoBcSt('B');
        $aliqIcmsSt = $objNfProd->getAliqIcmsSt('B');
        $aliqIpi = $objNfProd->getAliqIpi('B');
        $insideIpiBc = $objNfProd->getInsideIpiBc('B');
        $vlIcms = 0;
        $vlIpi = 0;
        $vlIcmsDiferido = 0;
        $vlIcmsOperacao = 0;
        $vlBcSt = 0;
        $vlIcmsSt = 0;
        $vlBcStRet = 0;
        $vlIcmsStRet = 0;
        $cstPis = $objNfProd->getCstPis();
        //Rodrigo
        if ($aliqPisMonofasica > 0.01):
            if (($origem==1) || ($origem==6)): 
                $cstPis = "02";
            else:
                $cstPis = "04";
            endif;
        endif;
        $aliqPis = $objNfProd->getAliqPis('B');
        $vlPis = 0;
        $cstCofins = $objNfProd->getCstCofins();
        //Rodrigo
        if ($aliqCofinsMonofasica > 0.01):
            if (($origem==1) || ($origem==6)): 
                $cstCofins = "02";
            else:
                $cstCofins = "04";
            endif;
        endif;        
        $aliqCofins = $objNfProd->getAliqCofins('B');
        $vlCofins = 0;
        $aliqFcpSt = $objNfProd->getAliqFcpSt('B');

        //Rodrigo
        //Como saber se o item calcula ST ou não*
            // Estado tem protocolo de ST?
            // NCM sujeita a ST?
            // Qual a MVA a ser utilizada (MVA Original ou MVA Ajustada)
            if ($crt==1){ // Simples Nacional
                $mvaSt=$objNfProd->getPercMvaSt('B');
            }
            else{
                $mvaSt=$objNfProd->getMvaAjustada('B');
            }
            // Trib ICMS 10/30/60/70/90     
        // Buscar a Alíquota de Importados 
        if ( ($crt==1) || ($origem=1) ){ // Simples Nacional
            $aliqIcms=4;   
        }
        
        //if (($crt!='3') and ($natOp!='2')):
        if (($crt=='1') and ($natOp!='2')):            
            $bcIcms = 0;
            $bcPis = 0;
            $bcCofins = 0;
        else:    
            $bcIcms = $totalProduto - $descontoProduto;
            $bcPis = $totalProduto - $descontoProduto;
            $bcCofins = $totalProduto - $descontoProduto;
        endif;

        //Rodrigo
        //RATEIO - Valor do Frete, Despesas Acessórias, Seguro
        //Rateio Frete para o item
        $freteNf=$objNotaFiscal->getFrete();
        $freteItem=$total*$freteNF/$totalProduto;
        //Rateio Desp Acess para o item
        $despAcessoriasNf=$objNotaFiscal->getDespesasAcessorias();
        $despAcessoriasItem=$total*$despAcessoriasNf/$totalProduto;
        //Seguro Acess para o item
        $seguroNf=$objNotaFiscal->getSeguro();
        $seguroItem=$total*$seguroNf/$totalProduto;      
        //Calcular a Base de IPI
        $bcIpi=$totalProduto-$descontoProduto+$freteItem+$despAcessoriasItem+$seguroItem;
        //Base de ICMS (com frete, desp. ac, seguro e redução BC)
        $bcIcms=$bcIcms+$freteItem+$despAcessoriasItem+$seguroItem;
        if ($percReducaoBc > 0.01){
            $bcIcms=$bcIcms-($bcIcms*$percReducaoBc/100);
        }
      
        // calcula IPI
        //o montante do IPI:

        // 1 - não integra a BC do ICMS quando o produto for destinado a posterior comercialização, industrialização ou outra saída tributada;
        // 2 - integra a BC do ICMS quando o produto for destinado a consumidor final, ativo imobilizado 
        $objNfProd->setValorIpi(0);
        if ($aliqIpi>0):
            //$vlIpi = ($aliqIpi/100)*$totalProduto;
            $vlIpi = $bcIpi*($aliqIpi/100); //Rodrigo
            if ($insideIpiBc=="S"): // Consumidor Final (tambem - somar o Ipi na Base de Cálculo)    
                $bcIcms += $vlIpi;
            endif;
            $objNfProd->setValorIpi($vlIpi);
        endif;


        switch ($arrTributos[0]['TRIBICMSSAIDA']){
            case '00': // tributado integralmente
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                // observacao
                
                //Rodrigo - DIFAL
                //<ICMSUFDest> - Informação do ICMS Interestadual
                // Grupo a ser informado nas vendas interestaduais para consumidor final, não contribuinte do ICMS.
                if ( ($contribuinteICMS="N") &&  
                     ($consumidorfinal="S")                                    
                ){                      
                    // <vBCUFDest> - Valor da BC do ICMS na UF destino
                    if (crt==1){ // Simples Nacional
                        $vlbcIcmsUfDest = $totalProduto-$descontoProduto+
                            $freteItem+$despAcessoriasItem+$seguroItem;
                    }
                    else{
                        $vlbcIcmsUfDest = $bcIcms;
                    }
                    //cAliqFecoepUFDest => $aliqFcpSt
                    //cAliqIcmsUFDest   => $aliqIcmsSt
                    if ($aliqFcpSt>0.01){
                        $aliqIcmsSt -= aliqFcpSt;
                    }

                    // <pFCPUFDest> - Percentual do ICMS relativo FCP na UF de destino $aliqFcpSt

                    // <pICMSUFDest> - Alíquota interna da UF de destino $aliqIcmsSt

                    // <pICMSInter> - Aliquota de ICMS interestadual - cAliqIcmsInter (4, 7, 12)
                    if ($origem==1){
                        $aliqIcmsInter = 4;
                    }
                    else {
                        $aliqIcmsInter = $aliqIcms;
                    }
                    //<pICMSInterPart> Percentual provisório de partilha do ICMS Interestadual 
                    // 100% a partir de 2019.
                    $aliqIcmsInterPart = 100.00;                    
                    //Cálculo FCP
                    if ($aliqFcpSt>0.01){
                        //<vBCFCPUFDest> - Valor da BC FCP na UF de destino
                        $bcFecoepUFDest = $vlbcIcmsUfDest;
                        //<vFCPUFDest> - Valor do FCP UF Dest
                        $vlFcpUfDest = $bcFecoepUFDest*($aliqFcpSt/100);
                    }
                    // <vICMSUFDest> Cálculo Difal  BC * (18-12=6)
                    $vlDifal = $vlbcIcmsUfDest * ($aliqIcmsSt-$aliqIcmsInter);                    
                    // <vICMSUFRemet> Valor do ICMS Interestadual para a UF do remetente
                    // Nota: A partir de 2019, este valor será zero.
                    $vlIcmsUFRemet = 0.00;
                }                             

                break;
            case '10': // Tributada e com cobrança do ICMS por substituição tributária
                $vlIcms = ($aliqIcms/100)*$bcIcms;

                //Rodrigo
                //Base de ICMS-ST
                //Cálculo ICMS-ST (Normal)
                if ( ($regimeespecialST=="N") && 
                    ($regimeespecialSTMT="N") &&
                    ($contribuinteICMS="S") &&  
                    ($consumidorfinal="N")                                    
                ){
                    $vlBcSt = $bcIcms;
                    if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                        $vlBcSt += $vlIpi;
                    endif;
                    $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                    $vlIcmsSt = (($vlBcSt)*($aliqIcmsSt/100)) - $vlIcms; //calcula icms st
                }
                //Cálculo ICMS-ST (DIFAL-ST)
                else if ( ($regimeespecialST=="N") && 
                    ($regimeespecialSTMT="N") &&
                    ($contribuinteICMS="S") &&  
                    ($consumidorfinal="S")                                    
                ){
                    $vlBcSt = $bcIcms;
                    if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                        $vlBcSt += $vlIpi;
                    endif;  

                    $vlBcSt = $bcIcms - $vlIcms;
                    $VlSubTribDif = 1 - ($aliqIcmsSt/100);
                    $vlBcSt = $vlBcSt/$VlSubTribDif;
                    $vlIcmsInterna = $vlBcSt*($aliqIcmsSt/100);
                    $vlIcmsSt = $vlIcmsInterna-$vlIcms;                    
                } 
                //Cálculo ICMS-ST (MT)
                else if ( ($regimeespecialST=="N") && 
                    ($ufDestino=="MT") && ($regimeespecialSTMT="S") &&
                    ($contribuinteICMS="S") 
                ){
                    if (($origem==1) || ($origem==6)){
                        $vlIcmsProprio = $vlBcSt*4/100;
                    }
                    else{
                        $vlIcmsProprio = $vlBcSt*$aliqIcms/100; 
                    }
                    //$valorSTEstimativa = ($vlBcSt + $vlIpi) * ($aliqRegEspSTMT/100);                    
                    $valorSTEstimativa = $vlBcSt* ($aliqRegEspSTMT/100);
                    $vlTotl=$vlIcmsProprio+$valorSTEstimativa/($aliqIcmsSt/100);
                    $vlIcmsSt=$valorSTEstimativa;
                    $vlBcSt=$vlTotl;
                }                    
                //ICMS-ST e FCP-ST
                if ($aliqFcpSt > 0.01){
                    $vlBcFcpSt = $eBaseSubTrib;
                    $vlFcpSt = $vlBcFcpSt*($aliqFcpSt/100);
                    //Descontar o valor da ST
                    $vlIcmsSt -= $vlFcpSt;
                }                
                break;
            case '20': // Tributação com redução de base de cálculo
                $bcIcms -= ($bcIcms*($percReduacaoBc/100)); // aplica reducao
                $vlIcms = ($aliqIcms/100)*$bcIcms;

                break;
            case '30': // Tributação Isenta ou não tributada e com cobrança do ICMS por substituição tributária
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*($vlBcSt)) - $vlIcms; //calcula icms st
                $bcIcms = 0;
                $vlIcms = 0;
                break;
            case '40': // Tributação Isenta, Não tributada ou Suspensão.
            case '41': // Tributação Isenta, Não tributada ou Suspensão.
            case '50': // Tributação Isenta, Não tributada ou Suspensão.
                $bcIcms = 0;
                $vlIcms = 0;
                $vlBcSt = 0;
                $vlIcmsSt = 0;
                $vlBcStRet = 0;
                $vlIcmsStRet = 0;
                break;
            case '51': // Tributação com Diferimento (a exigência do preenchimento das
                       //informações do ICMS diferido fica a critério de cada UF).

                $bcIcms = ($percReducaoBc/100)*$totalProduto;
                $vlIcmsDiferido = ($percDiferido/100)*$bcIcms;
                $vlIcmsOperacao = ($aliqIcms/100)*$bcIcms;
                $vlIcms = $vlIcmsOperacao-$vlIcmsDiferido;
                break;
            case '60': // Tributação ICMS cobrado anteriormente por substituição tributária
                // buscar valor de impostos retido na nf de entrada
                /*
                O CST 060 significa: mercadoria de origem nacional, e ICMS cobrado anteriormente por Substituição Tributária.
                Como o ICMS já foi cobrado anteriormente, esse imposto NÃO deve ser destacado na próxima circulação da mercadoria, 
                em operações internas. Então, utiliza-se o CST 060. 
                O ICMS devido por este contribuinte já foi pago na entrada da mercadoria, por Substituição Tributária, 
                com margem de lucro e já recolhido aos cofres estaduais, pelo remetente. 
                Portanto o sistema está correto em não destacar “Base de Cálculo do ICMS” e “Valor do ICMS”, 
                porque o imposto já foi recolhido por ST. 
                É necessário, porém, que seja informado no campo “Dados Adicionais – Informações Complementares”, da nota fiscal, 
                o dispositivo legal que permite o não destaque do ICMS; em SC, o dispositivo legal é: 

                “ Imposto Retido por Substituição Tributária – RICMS-SC/01 – Anexo 3”. 

                Em toda nota fiscal, modelo 1, 1-A ou 55 (eletrônica), é obrigatório informar qual o dispositivo legal que permite 
                o não destaque do ICMS. 
                Há também nos Regulamentos de ICMS, uma determinação que seja indicada no campo “Dados Adicionais – 
                Informações Complementares”, quando da emissão dos mesmos modelos de notas fiscais acima mencionados, 
                a base de cálculo e o valor do imposto retido, salvo nas saídas destinadas a não contribuinte. 

                Essas informações são obtidas na NF de compra, onde o ICMS Substituto é cobrado. 
                Se faz necessária esse informação porque o destinatário poderá creditar esse ICMS, 
                no caso de mercadoria para industrialização ou ativo imbolizado. 

                Quem utiliza o CST 060, é o Contribuinte Substituído, ou seja, aquele que pagou antecipadamente o 
                ICMS que seria de sua obrigação, quando da saída posterior da mercadoria.                  

                 */
                $bcIcms = 0;
                // ******* buscat o valor st retido na nf de entrada
                $vlBcStRet = 0;
                $vlIcmsStRet = 0;
                break;
            case '70': // Tributação ICMS com redução de base de cálculo e cobrança
                       // do ICMS por substituição tributária
                $bcIcms -= ($bcIcms*($percReducaoBc/100)); // aplica reducao Bc
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*$vlBcSt) - $vlIcms; //calcula icms st


                break;
            case '90': // Tributação ICMS: Outros
                $bcIcms -= ($bcIcms*($percReduacaoBc/100)); // aplica reducao Bc
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*$vlBcSt) - $vlIcms; //calcula icms st
                break;
            case '102': // Tributação com redução de base de cálculo
                $bcIcms -= ($bcIcms*($percReducaoBc/100)); // aplica reducao
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                break;    
        }

        // calululo PIS
        switch ($cstPis){
            case '01': // Operação Tributável (base de cálculo = valor da operação alíquota normal (cumulativo/não cumulativo)); 
                $vlPis = ($bcPis * $aliqPis) / 100;
                break;            
            case '02': // Operação Tributável (base de cálculo = valor da operação (alíquota diferenciada)); 
                $vlPis = ($bcPis * $aliqPisMonofasica) / 100;
                break;
            case '03': //Operação Tributável (base de cálculo = quantidade vendida x alíquota por unidade de produto)
                $bcPis = $objNfProd->getQuant();
                $vAliqProd = $aliqPis;
                $vlPis = ($bcPis * $vAliqProd);
                break;
            case '04': 
            case '05': 
            case '06': 
            case '07': 
            case '08': 
            case '09': 
                $bcPis = 0;
                $aliqPis = 0;
                $vlPis = 0;
                break;
            default :
                $vlPis = ($bcPis * $aliqPis) / 100;
        }
        
        // calululo COFINS
        switch ($cstCofins){
            case '01': // Operação Tributável (base de cálculo = valor da operação alíquota normal (cumulativo/não cumulativo)); 
                $vlCofins = ($bcCofins * $aliqCofins) / 100;
                break;            
            case '02': // Operação Tributável (base de cálculo = valor da operação (alíquota diferenciada)); 
                $vlCofins = ($bcCofins * $aliqCofinsMonofasica) / 100;
                break;
            case '03': //Operação Tributável (base de cálculo = quantidade vendida x alíquota por unidade de produto)
                $bcCofins = $objNfProd->getQuant();
                $vAliqProd = $aliqCofins;
                $vlCofins = ($bcCofins * $vAliqProd) / 100;
                break;
            case '04': 
            case '05': 
            case '06': 
            case '07': 
            case '08': 
            case '09': 
                $bcCofins = 0;
                $aliqCofins = 0;
                $vlCofins = 0;
                break;
            default :
                $vlCofins = ($bcCofins * $aliqCofins) / 100;
        }
        
        $objNfProd->setBcIcms($bcIcms, true);
        $objNfProd->setValorIcms($vlIcms, true);

        $objNfProd->setValorIcmsDiferido($vlIcmsDiferido, true);
        $objNfProd->setValorIcmsOperacao($vlIcmsOperacao, true);

        $objNfProd->setValorBcSt($vlBcSt, true);
        $objNfProd->setValorIcmsSt($vlIcmsSt, true);

        //Rodrigo
        $objNfProd->setMvaSt($mvaSt, true);
        $objNfProd->setAliqIcmsSt($aliqIcmsSt, true);
        $objNfProd->setAliqRedBCST($percReduacaoBcSt, true);  
        //Aliq de Pis, Cofins, Icms, não precisa setar?       
        // DIFAL
        // <vBCUFDest> - Valor da BC do ICMS na UF destino
        $objNfProd->setValorIcmsUfDest($vlbcIcmsUfDest, true);
        // <vBCFCPUFDest> - Valor da BC FCP na UF de destino
        $objNfProd->setValorIcmsUfDest($bcFecoepUFDest, true);
        // <pFCPUFDest> - Percentual do ICMS relativo FCP na UF de destino
        $objNfProd->setAliqIcmsUfDest($aliqFcpSt, true);        
        // <pICMSUFDest>
        $objNfProd->setAliqIcmsUfDest($aliqIcmsSt, true);        
        // <pICMSInter> - Aliquota de ICMS interestadual
        $objNfProd->setAliqIcmsInter($aliqIcmsInter, true);
        // <pICMSInterPart> Percentual provisório de partilha do ICMS Interestadual         
        // ?? vai sempre 100.00 - 
        $objNfProd->setAliqIcmsInterPart($aliqIcmsInterPart, true);
        // <vFCPUFDest> - Valor do FCP
        $objNfProd->setFcpUfDest($vlFcpUfDest, true);
        // <vICMSUFDest> Cálculo Difal  BC * (18-12=6)
        $objNfProd->setValorIcmsUfDest($vlDifal, true);
        // <vICMSUFRemet> Valor do ICMS Interestadual para a UF do remetente
        // ?? vai sempre 0.00 - 
        $objNfProd->setValorIcmsUFRemet($vlIcmsUFRemet, true);

        $objNfProd->setBcPis($bcPis, true);
        $objNfProd->setValorPis($vlPis, true);
        $objNfProd->setBcCofins($bcCofins, true);
        $objNfProd->setValorCofins($vlCofins, true);
        
        return true;
    else:
        return false;
    endif;

} //fim calculaImpostos


}	//	END OF THE CLASS
?>
