<?php
/**
 * @package   astecv3
 * @name      c_pedido_venda_nf
 * @version   3.0.00
 * @copyright 2016
 * @link      http://www.admservice.com.br/
 * @author    Marcio Sergio da Silva<marcio.sergio@admservice.com.br>
 * @date      06/12/2016
 */

$dir = dirname(__FILE__);
include_once($dir . "/../../class/ped/c_pedido_venda.php");
include_once($dir . "/../../bib/c_date.php");
include_once($dir . "/../../bib/c_tools.php");

//Class 
Class c_pedidoVendaNf extends c_pedidoVenda {

    //construtor
function __construct(){
        // session_start();
        // Cria uma instancia variaveis de sessao
        c_user::from_array($_SESSION['user_array']);
}


/**
* METODOS DE SETS E GETS
*/

//############### FIM SETS E GETS ###############


/**
 * <b> Calcaula as parcelas para ser lancadas no financeiro, a primeira parcela o valor é ajusto para fechar com o total da NF </b>
 * @name calculaParcelasNfe
 * @param VARCHAR condPgto
 * @param int total
 * @return Matriz com as datas de vencimento e valores de cada parcela.
 */
public function calculaParcelasNfe($condPgto = NULL, $total = 0, $acrescentarParcela = 0, $bonus = 0){
    $consulta = new c_banco();
    $sql = "select PARCELA, VENCIMENTO, TOTAL as VALOR, SITPGTO ,IF (SITPGTO = 'B', 'BAIXADO', '') AS SITPAG FROM FIN_LANCAMENTO WHERE DOCTO = '".$this->getPedido()."' AND ORIGEM = 'PED' AND SITPGTO = 'B'";
    $consulta->exec_sql($sql);
    $consulta->close_connection();
    $parcsBaixada = $consulta->resultado;
    $totalParcs = 0;
    foreach($parcsBaixada as $key => $value){
        $totalParcs += $value['VALOR'];
    }
    $totalNumParcelas = 0;

    //setlocale(LC_MONETARY, 'en_US');
    $descCondPgto = str_replace('DIAS', '', $condPgto);
    $parcelas = explode("/", $condPgto);
    $numParcelas = count($parcelas);
    $totalGeral = $total - $bonus;
    //diminui o valor das parcelas pagas
    if ($totalParcs > 0){
        $totalGeral -= $totalParcs;
    }
    if ($totalGeral > 0 ) {
    //$valorParcela = money_format('%i', $totalGeral / $numParcelas);
    //$valorParcela =  str_replace(number_format(($totalGeral / $numParcelas),2),',','');
    $valorParcela =  round($totalGeral / $numParcelas, 2, PHP_ROUND_HALF_DOWN); 
    if ($acrescentarParcela > 0 ){
        $totalNumParcelas += $acrescentarParcela;
    }
    if ($bonus > 0){
        $totalNumParcelas += 1;        
    }
    $totalNumParcelas += $numParcelas;
    if ($totalGeral == 0){
        $totalNumParcelas = 1;        
    }
    
    for ($i = 0; $i < $totalNumParcelas; $i++) {
        if ( ($i == 0) and ($bonus > 0) ) {
            $lanc[$i]['PARCELA'] = $i + 1;
            $lanc[$i]['VENCIMENTO'] = date("Y-m-d", strtotime(date("Y-m-d") . "  + ".intval(0)." day"));
            $lanc[$i]['VALOR'] = $bonus;  
            $lanc[$i]['TIPODOCTO_ID'] = 'N';
        } else if ($i <= $numParcelas) {
            $lanc[$i]['PARCELA'] = $i + 1;
            $lanc[$i]['VENCIMENTO'] = date("Y-m-d", strtotime(date("Y-m-d") . "  + ".intval($parcelas[$i])." day"));
            $lanc[$i]['VALOR'] = $valorParcela; 
            $lanc[$i]['TIPODOCTO_ID'] = '';   
        } else {
            $lanc[$i]['PARCELA'] = $i + 1;
            $lanc[$i]['VENCIMENTO'] = date("Y-m-d", strtotime(date("Y-m-d") . "  + ".intval($parcelas[$numParcelas - 1])." day"));
            $lanc[$i]['VALOR'] = 0;    
            $lanc[$i]['TIPODOCTO_ID'] = '';
        }
    }

    //$lanc[0]['VALOR'] = $valorParcela - (($valorParcela * $numParcelas) - doubleval($totalGeral));
    if (($valorParcela * $numParcelas) < doubleval($totalGeral)){
        $dif = (doubleval($totalGeral) - ($valorParcela * $numParcelas)) ;
        $lanc[$totalNumParcelas - 1]['VALOR'] +=  $dif;    
    }else if (($valorParcela * $numParcelas) > doubleval($totalGeral)){
        $dif = (($valorParcela * $numParcelas) - doubleval($totalGeral)) ;
        $lanc[$totalNumParcelas - 1]['VALOR'] -=  $dif;    
    }    
    //$lanc[0]['VALOR'] = str_replace(".", ",",$lanc[0]['VALOR']);
    //return $lanc;
    } else if ($bonus > 0) {
        $i = 0;
        $lanc[$i]['PARCELA'] = $i + 1;
        $lanc[$i]['VENCIMENTO'] = date("Y-m-d", strtotime(date("Y-m-d") . "  + ".intval(0)." day"));
        $lanc[$i]['VALOR'] = $bonus;  
        $lanc[$i]['TIPODOCTO_ID'] = 'N';
    }
    
    $newLanc[] = '';
    $count = 0;
    for($k=0; $k < count($parcsBaixada); $k++){
        if($newLanc[0] == ''){
            $newLanc[$k] = $parcsBaixada[$k];
        }else{
            array_push($newLanc, $parcsBaixada[$k]);
        }
        $count += 1;
    }

    if ($count > 0) {
        for($l = 0; $l < count($lanc); $l++){
            $newLanc[$count] = $lanc[$l];
            $count += 1;
            //array_push($newLanc[$count+=1], $lanc[$l]);
        }
        return $newLanc;
    } else {
        return $lanc;
    }

    
    
}

/**
 * <b> Calcaula as parcelas para ser lancadas no financeiro, a primeira parcela o valor é ajusto para fechar com o total da NF </b>
 * @name calculaParcelasNfe
 * @param VARCHAR condPgto
 * @param int total
 * @return Matriz com as datas de vencimento e valores de cada parcela.
 */
public function calculaParcelasAlteraPed($condPgto = NULL, $total = 0, $acrescentarParcela = 0, $bonus = 0){
    
    //PESQUISA SE TEM PARCELAS BAIXADAS FINANCEIRO
    $consulta = new c_banco();
    $sql = "select PARCELA, VENCIMENTO, TOTAL as VALOR, SITPGTO ,IF (SITPGTO = 'B', 'BAIXADO', '') AS SITPAG FROM FIN_LANCAMENTO WHERE DOCTO = '".$this->getPedido()."' AND ORIGEM = 'PED' AND SITPGTO = 'B'";
    $consulta->exec_sql($sql);
    $consulta->close_connection();
    $parcsBaixada = $consulta->resultado;
    $totalParcs = 0;
    foreach($parcsBaixada as $key => $value){
        $totalParcs += $value['VALOR'];
    }
    $totalNumParcelas = 0;
    //setlocale(LC_MONETARY, 'en_US');
    $descCondPgto = str_replace('DIAS', '', $condPgto);
    $parcelas = explode("/", $condPgto);
    $numParcelas = count($parcelas);
    if ($acrescentarParcela > 0 ){
        $totalNumParcelas += $acrescentarParcela;
    }
    $totalNumParcelas += $numParcelas;
    $totalGeral = $total - $bonus - $totalParcs;
    //$valorParcela = money_format('%i', $totalGeral / $numParcelas);
    //$valorParcela =  str_replace(number_format(($totalGeral / $numParcelas),2),',','');
    $valorParcela =  round($totalGeral / $totalNumParcelas, 2, PHP_ROUND_HALF_DOWN); 
    //if ($acrescentarParcela > 0 ){
    //    $totalNumParcelas += $acrescentarParcela;
    //}
    if ($bonus > 0){
        $totalNumParcelas += 1;        
    }
    //$totalNumParcelas += $numParcelas;
    if ($totalGeral == 0){
        $totalNumParcelas = 1;        
    }
    $parcsBaixada != 0 ? $counter = (count($parcsBaixada) + 1) : $counter = 1;
    for ($i = 0; $i < $totalNumParcelas; $i++) {
        if ( ($i == 0) and ($bonus > 0) ) {
            $lanc[$i]['PARCELA'] = $i + $counter;
            $lanc[$i]['VENCIMENTO'] = date("Y-m-d", strtotime(date("Y-m-d") . "  + ".intval(0)." day"));
            $lanc[$i]['VALOR'] = $bonus;  
            $lanc[$i]['TIPODOCTO_ID'] = 'N';
        } else if ($i <= $totalNumParcelas) {
            $lanc[$i]['PARCELA'] = $i + $counter;
            $lanc[$i]['VENCIMENTO'] = date("Y-m-d", strtotime(date("Y-m-d") . "  + ".intval($parcelas[$i])." day"));
            $lanc[$i]['VALOR'] = $valorParcela; 
            $lanc[$i]['TIPODOCTO_ID'] = '';   
        } else {
            $lanc[$i]['PARCELA'] = $i + $counter;
            $lanc[$i]['VENCIMENTO'] = date("Y-m-d", strtotime(date("Y-m-d") . "  + ".intval($parcelas[$numParcelas - 1])." day"));
            $lanc[$i]['VALOR'] = 0;    
            $lanc[$i]['TIPODOCTO_ID'] = '';
        }
    }
    $newLanc[] = '';
    $count = 0;
    for($k=0; $k < count($parcsBaixada); $k++){
        if($newLanc[0] == ''){
            $newLanc[$k] = $parcsBaixada[$k];
        }else{
            array_push($newLanc, $parcsBaixada[$k]);
        }
        $count += 1;
    }

    for($l = 0; $l < count($lanc); $l++){
        $newLanc[$count] = $lanc[$l];
        $count += 1;
        //array_push($newLanc[$count+=1], $lanc[$l]);
    }

    
    return $newLanc;
}

/**
 * <b> É responsavel por buscar informações da tabela tritutos para calculo dos impostos da NFe </b>
 * <b> os campos NCM e CEST são opcionais </b>
 * @name calculaImpostosNfe
 * @param int natOp
 * @param VARCHAR uf
 * @param CHAR tipoPessoa
 * @param VARCHAR origem 
 * @param VARCHAR tribIcms
 * @param VARCHAR ncm
 * @param VARCHAR cest
 * @return vazio - os campos são calculados e setados dentro da função, não havendo retorno.
 * https://blog.tecnospeed.com.br/como-calcular-o-icms-na-nf-e-e-nfc-e/
 */
public function calculaImpostosNfe($objNfProd = NULL, $natOp = NULL, $uf=NULL, $tipoPessoa=NULL, $centroCusto=NULL){

    $arrTributos =  [];
    $origem=$objNfProd->getOrigem();
    $tribIcms=$objNfProd->getTribIcms();
    $ncm=$objNfProd->getNcm();
    $cest=$objNfProd->getCest();

    // BUSCA CRT EMPRESA
    $banco = new c_banco();
    $sql = "select * from amb_empresa where (centrocusto=".$centroCusto.")";
    //$sql = "select * from amb_empresa where (centrocusto=".$this->m_empresacentrocusto.")";
    $emp = $banco->exec_sql($sql);
    $crt=$emp[0]['REGIMETRIBUTARIO'];


    $sql  = "SELECT N.PRECCREDITOSIMPLES, T.* FROM EST_NAT_OP_TRIBUTO T ";
    $sql .= "INNER JOIN EST_NAT_OP N ON (N.ID=T.IDNATOP) ";
    $sql .= "WHERE (T.CENTROCUSTO =".$centroCusto.") AND (T.IDNATOP =".$natOp.") AND (T.UF='".$uf."') AND (T.PESSOA='".$tipoPessoa."') ";
    // $sql .= "WHERE (CENTROCUSTO =".$this->m_empresacentrocusto.") AND (IDNATOP =".$natOp.") AND (UF='".$uf."') AND (PESSOA='".$tipoPessoa."') ";
    if (($natOp=='2') and ($crt!='3')){
        if ($origem!='') {
            $sql .= " AND (T.ORIGEM='".$origem."') ";        
        }
        if ($tribIcms!='') {
            $sql .= " AND (T.TRIBICMS='".$tribIcms."') ";        
        }
        if ($ncm!='') {
            $sql .= " AND ((T.NCM='".$ncm."') OR (T.NCM='')) ";        
        }
        if ($cest!='') {
            $sql .= " AND ((T.CEST='".$cest."') OR (T.CEST='')) ";
        }
    } else if ($crt=='3') {
        $sql .= " AND (T.ORIGEM='".$origem."') AND (T.TRIBICMS='".$tribIcms."') AND ((T.NCM='".$ncm."') OR (T.NCM='')) AND ((T.CEST='".$cest."') OR (T.CEST=''))";
    } else {    
        $sql .= " AND (T.ORIGEM='".$origem."')";
    }
    $sql .= ' ORDER BY T.NCM DESC';
    
   // echo strtoupper($sql);
    $banco->exec_sql($sql);
    $banco->close_connection();
    $arrTributos =  $banco->resultado;
    if (isset($arrTributos)):

        // seta aliquotas
        $objNfProd->setCfop($arrTributos[0]['CFOP']);
        $objNfProd->setAliqIcms($arrTributos[0]['ALIQICMS'], true);
        $objNfProd->setPercReducaoBc($arrTributos[0]['PERCREDUCAOBC'], true);
        $objNfProd->setModBc($arrTributos[0]['MODBC']);
        $objNfProd->setPercDiferido($arrTributos[0]['PERCDIFERIDO'], true);
        $objNfProd->setModBcSt($arrTributos[0]['MODBCST']);
        $objNfProd->setPercMvaSt($arrTributos[0]['MVAST'], true);
        $objNfProd->setPercReducaoBcSt($arrTributos[0]['PERCREDUCAOBCST'], true);
        $objNfProd->setAliqIcmsSt($arrTributos[0]['ALIQICMSST'], true);
        $objNfProd->setAliqIpi($arrTributos[0]['ALIQIPI'], true);
        $objNfProd->setInsideIpiBc($arrTributos[0]['INSIDEIPIBC']);
        $objNfProd->setCstPis($arrTributos[0]['CSTPIS']);
        $objNfProd->setAliqPis($arrTributos[0]['ALIQPIS'], true);
        $objNfProd->setCstCofins($arrTributos[0]['CSTCOFINS']);
        $objNfProd->setAliqCofins($arrTributos[0]['ALIQCOFINS'], true);
        $objNfProd->setTribIcms($arrTributos[0]['TRIBICMSSAIDA']);
        $objNfProd->setCBenef($arrTributos[0]['CBENEF']);
        $objNfProd->setPCredSN($arrTributos[0]['PRECCREDITOSIMPLES'], true);


        // inicializa campos , SEM PARAMETRO DE FORMATAÇÃO PARA TRAZER DEFAULT
        $totalProduto = $objNfProd->getTotal('B');
        $descontoProduto = $objNfProd->getDesconto('B');
        $aliqIcms = $objNfProd->getAliqIcms('B');
        $percReducaoBc = $objNfProd->getPercReducaoBc('B');
        $percDiferido = $objNfProd->getPercDiferido('B');
        $mvaSt = $objNfProd->getPercMvaSt('B');
        $percReduacaoBcSt = $objNfProd->getPercReducaoBcSt('B');
        $aliqIcmsSt = $objNfProd->getAliqIcmsSt('B');
        $aliqIpi = $objNfProd->getAliqIpi('B');
        $insideIpiBc = $objNfProd->getInsideIpiBc('B');
        $vlIcms = 0;
        $vlIpi = 0;
        $vlIcmsDiferido = 0;
        $vlIcmsOperacao = 0;
        $vlBcSt = 0;
        $vlIcmsSt = 0;
        $vlBcStRet = 0;
        $vlIcmsStRet = 0;
        $cstPis = $objNfProd->getCstPis();
        $aliqPis = $objNfProd->getAliqPis('B');
        $vlPis = 0;
        $cstCofins = $objNfProd->getCstCofins();
        $aliqCofins = $objNfProd->getAliqCofins('B');
        $vlCofins = 0;
        $pCredSN = $objNfProd->getPCredSN('B');
        $vCredICMSSN = 0;

        
        if (($crt!='3') and ($natOp!='2')):
            $bcIcms = 0;
            $bcPis = 0;
            $bcCofins = 0;
        else:    
            $bcIcms = $totalProduto - $descontoProduto;
            $bcPis = $totalProduto - $descontoProduto;
            $bcCofins = $totalProduto - $descontoProduto;
        endif;
        
        // calcula IPI
        //o montante do IPI:

        // 1 - não integra a BC do ICMS quando o produto for destinado a posterior comercialização, industrialização ou outra saída tributada;
        // 2 - integra a BC do ICMS quando o produto for destinado a consumidor final, ativo imobilizado 
        $objNfProd->setValorIpi(0);
        if ($aliqIpi>0):
            $vlIpi = ($aliqIpi/100)*$totalProduto;
            if ($insideIpiBc=="S"):
                $bcIcms += $vlIpi;
            endif;
            $objNfProd->setValorIpi($vlIpi);
        endif;

        switch ($arrTributos[0]['TRIBICMSSAIDA']){
            case '00': // tributado integralmente
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                // observacao
                break;
            case '10': // Tributada e com cobrança do ICMS por substituição tributária
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*($vlBcSt)) - $vlIcms; //calcula icms st

                break;
            case '20': // Tributação com redução de base de cálculo
                $bcIcms -= ($bcIcms*($percReduacaoBc/100)); // aplica reducao
                $vlIcms = ($aliqIcms/100)*$bcIcms;

                break;
            case '30': // Tributação Isenta ou não tributada e com cobrança do ICMS por substituição tributária
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*($vlBcSt)) - $vlIcms; //calcula icms st
                $bcIcms = 0;
                $vlIcms = 0;
                break;
            case '40': // Tributação Isenta, Não tributada ou Suspensão.
            case '41': // Tributação Isenta, Não tributada ou Suspensão.
            case '50': // Tributação Isenta, Não tributada ou Suspensão.
                $bcIcms = 0;
                $vlIcms = 0;
                $vlBcSt = 0;
                $vlIcmsSt = 0;
                $vlBcStRet = 0;
                $vlIcmsStRet = 0;
                break;
            case '51': // Tributação com Diferimento (a exigência do preenchimento das
                       //informações do ICMS diferido fica a critério de cada UF).
                /*
                $bcIcms = ($percReducaoBc/100)*$totalProduto;
                $vlIcmsDiferido = ($percDiferido/100)*$bcIcms;
                $vlIcmsOperacao = ($aliqIcms/100)*$bcIcms;
                $vlIcms = $vlIcmsOperacao-$vlIcmsDiferido;
                */
                $bcIcms = $totalProduto;
                $vlIcmsOperacao = ($totalProduto *  $aliqIcms ) / 100 ;
                $vlIcmsDiferido = ($vlIcmsOperacao * ($percDiferido /  100 ) );
                $vlIcms = $vlIcmsOperacao - $vlIcmsDiferido; 
                
                break;
            case '60': // Tributação ICMS cobrado anteriormente por substituição tributária
                // buscar valor de impostos retido na nf de entrada
                /*
                O CST 060 significa: mercadoria de origem nacional, e ICMS cobrado anteriormente por Substituição Tributária.
                Como o ICMS já foi cobrado anteriormente, esse imposto NÃO deve ser destacado na próxima circulação da mercadoria, 
                em operações internas. Então, utiliza-se o CST 060. 
                O ICMS devido por este contribuinte já foi pago na entrada da mercadoria, por Substituição Tributária, 
                com margem de lucro e já recolhido aos cofres estaduais, pelo remetente. 
                Portanto o sistema está correto em não destacar “Base de Cálculo do ICMS” e “Valor do ICMS”, 
                porque o imposto já foi recolhido por ST. 
                É necessário, porém, que seja informado no campo “Dados Adicionais – Informações Complementares”, da nota fiscal, 
                o dispositivo legal que permite o não destaque do ICMS; em SC, o dispositivo legal é: 

                “ Imposto Retido por Substituição Tributária – RICMS-SC/01 – Anexo 3”. 

                Em toda nota fiscal, modelo 1, 1-A ou 55 (eletrônica), é obrigatório informar qual o dispositivo legal que permite 
                o não destaque do ICMS. 
                Há também nos Regulamentos de ICMS, uma determinação que seja indicada no campo “Dados Adicionais – 
                Informações Complementares”, quando da emissão dos mesmos modelos de notas fiscais acima mencionados, 
                a base de cálculo e o valor do imposto retido, salvo nas saídas destinadas a não contribuinte. 

                Essas informações são obtidas na NF de compra, onde o ICMS Substituto é cobrado. 
                Se faz necessária esse informação porque o destinatário poderá creditar esse ICMS, 
                no caso de mercadoria para industrialização ou ativo imbolizado. 

                Quem utiliza o CST 060, é o Contribuinte Substituído, ou seja, aquele que pagou antecipadamente o 
                ICMS que seria de sua obrigação, quando da saída posterior da mercadoria.                  

                 */
                $bcIcms = 0;
                // ******* buscat o valor st retido na nf de entrada
                $vlBcStRet = 0;
                $vlIcmsStRet = 0;
                break;
            case '70': // Tributação ICMS com redução de base de cálculo e cobrança
                       // do ICMS por substituição tributária
                $bcIcms -= ($bcIcms*($percReducaoBc/100)); // aplica reducao Bc
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*$vlBcSt) - $vlIcms; //calcula icms st


                break;
            case '90': // Tributação ICMS: Outros
                $bcIcms -= ($bcIcms*($percReduacaoBc/100)); // aplica reducao Bc
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*$vlBcSt) - $vlIcms; //calcula icms st
                break;
            case '101': // Tributada e com cobrança do ICMS por substituição tributária
                $bcIcmsSN = $totalProduto - $descontoProduto;
                // $vlIcms = ($aliqIcms/100)*$bcIcms;
                // $vlBcSt = $bcIcms;
                // if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                //     $vlBcSt += $vlIpi;
                // endif;
                // $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                // $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                // $vlIcmsSt = (($aliqIcmsSt/100)*($vlBcSt)) - $vlIcms; //calcula icms st
                $vCredICMSSN = $bcIcmsSN * ($pCredSN / 100);
                break;
            case '102': // Tributação com redução de base de cálculo
                $bcIcms -= ($bcIcms*($percReducaoBc/100)); // aplica reducao
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                break; 
            case '201': // Tributada e com cobrança do ICMS por substituição tributária
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*($vlBcSt)) - $vlIcms; //calcula icms st

                break;
            case '202': // Tributada e com cobrança do ICMS por substituição tributária
                $bcIcms = $totalProduto - $descontoProduto;
                $vlIcms = ($aliqIcms/100)*$bcIcms;
                $vlBcSt = $bcIcms;
                if ($insideIpiBc=="N"): // soma vl ipi na base de calculo de ST
                    $vlBcSt += $vlIpi;
                endif;
                $vlBcSt = ($vlBcSt * $mvaSt); // aplica indice mva bc st
                $vlBcSt -= ($vlBcSt*($percReduacaoBcSt/100)); // aplica redução bc st
                $vlIcmsSt = (($aliqIcmsSt/100)*($vlBcSt)) - $vlIcms; //calcula icms st
                $pCredSN = 0;
                $vCredICMSSN = 0;
                break;   
        }

        // calululo PIS
        switch ($cstPis){
            case '01': // Operação Tributável (base de cálculo = valor da operação alíquota normal (cumulativo/não cumulativo)); 
            case '02': // Operação Tributável (base de cálculo = valor da operação (alíquota diferenciada)); 
                $vlPis = ($bcPis * $aliqPis) / 100;
                break;
            case '03': //Operação Tributável (base de cálculo = quantidade vendida x alíquota por unidade de produto)
                $bcPis = $objNfProd->getQuant();
                $vAliqProd = $aliqPis;
                $vlPis = ($bcPis * $vAliqProd);
                break;
            case '04': 
            case '05': 
            case '06': 
            case '07': 
            case '08': 
            case '09': 
                $bcPis = 0;
                $aliqPis = 0;
                $vlPis = 0;
                break;
            default :
                $vlPis = ($bcPis * $aliqPis) / 100;
        }
        
        // calululo COFINS
        switch ($cstCofins){
            case '01': // Operação Tributável (base de cálculo = valor da operação alíquota normal (cumulativo/não cumulativo)); 
            case '02': // Operação Tributável (base de cálculo = valor da operação (alíquota diferenciada)); 
                $vlCofins = ($bcCofins * $aliqCofins) / 100;
                break;
            case '03': //Operação Tributável (base de cálculo = quantidade vendida x alíquota por unidade de produto)
                $bcCofins = $objNfProd->getQuant();
                $vAliqProd = $aliqCofins;
                $vlCofins = ($bcCofins * $vAliqProd) / 100;
                break;
            case '04': 
            case '05': 
            case '06': 
            case '07': 
            case '08': 
            case '09': 
                $bcCofins = 0;
                $aliqCofins = 0;
                $vlCofins = 0;
                break;
            default :
                $vlCofins = ($bcCofins * $aliqCofins) / 100;
        }
        
        $objNfProd->setBcIcms($bcIcms, true);
        $objNfProd->setValorIcms($vlIcms, true);

        $objNfProd->setValorIcmsDiferido($vlIcmsDiferido,true);
        $objNfProd->setValorIcmsOperacao($vlIcmsOperacao,true);

        $objNfProd->setValorBcSt($vlBcSt, true);
        $objNfProd->setValorIcmsSt($vlIcmsSt, true);

        $objNfProd->setBcPis($bcPis, true);
        $objNfProd->setValorPis($vlPis, true);
        $objNfProd->setBcCofins($bcCofins, true);
        $objNfProd->setValorCofins($vlCofins, true);

        $objNfProd->setVCredICMSSN($vCredICMSSN, true);

        return true;
    else:
        return false;
    endif;

} //fim calculaImpostos


}	//	END OF THE CLASS
?>
