<?php
/**
 * @package   astec
 * @name      p_consultas
 * @version   3.0.00
 * @copyright 2020
 * @link      http://www.admservice.com.br/
 * @author    Tony Hashimoto 
 * @date      13/05/2020
 */
// Evita que usuários acesse este arquivo diretamente
if (!defined('ADMpath')): exit; endif;

$dir = dirname(__FILE__);

require_once($dir."/../../../smarty/libs/Smarty.class.php");
require_once($dir."/../../class/ped/c_pedido_venda_relatorios.php");
include_once($dir."/../../class/fin/c_lancamento.php");
require_once($dir . "/../../class/ped/c_pedido_venda_nf.php");
require_once($dir . "/../../class/est/c_produto.php");
require_once($dir . "/../../class/est/c_cond_pgto.php");

//Class p_rel_pedidos
Class p_rel_pedidos extends c_pedido_venda_relatorios {

    private $m_submenu = null;
    private $m_letra = null;
    private $m_opcao = null;

    public $tpRelatorio = null;

    public $m_par = NULL;
    public $motivoSelecionados     = NULL;
    public $vendedorSelecionados   = NULL;
    public $condPagSelecionados    = NULL;
    public $situacaoSelecionados   = NULL;
    public $centroCustoSelecionados= NULL;    

    /**
     * <b> Função magica construct </b>
     * @param VARCHAR $submenu
     * @param VARCHAR $letra
     * 
     */
    function __construct() {

        //Assim obtém os dados passando pelo filtro contra INJECTION ( segurança PHP )
        $parmPost = filter_input_array(INPUT_POST, FILTER_DEFAULT);
        $parmGet = filter_input_array(INPUT_GET, FILTER_DEFAULT);  
        
       // Cria uma instancia variaveis de sessao
        session_start();
        c_user::from_array($_SESSION['user_array']);

        // Cria uma instancia do Smarty
        $this->smarty = new Smarty;

        // caminhos absolutos para todos os diretorios do Smarty
        $this->smarty->template_dir = ADMraizFonte . "/template/ped";
        $this->smarty->compile_dir = ADMraizCliente . "/smarty/templates_c/";
        $this->smarty->config_dir = ADMraizCliente . "/smarty/configs/";
        $this->smarty->cache_dir = ADMraizCliente . "/smarty/cache/";

        // inicializa variaveis de controle
        $this->m_submenu=(isset($parmGet['submenu']) ? $parmGet['submenu'] : (isset($parmPost['submenu']) ? $parmPost['submenu'] : ''));
        $this->m_letra=(isset($parmGet['letra']) ? $parmGet['letra'] : (isset($parmPost['letra']) ? $parmPost['letra'] : ''));
        $this->m_opcao=(isset($parmGet['opcao']) ? $parmGet['opcao'] : (isset($parmPost['opcao']) ? $parmPost['opcao'] : ''));

        $this->tpRelatorio=(isset($parmGet['tipoRelatorio']) ? $parmGet['tipoRelatorio'] : (isset($parmPost['tipoRelatorio']) ? $parmPost['tipoRelatorio'] : ''));
        $this->motivoSelecionados=(isset($parmGet['motivoSelected']) ? $parmGet['motivoSelected'] : '');
        $this->vendedorSelecionados=(isset($parmGet['vendedorSelected']) ? $parmGet['vendedorSelected'] : '');
        $this->condPagSelecionados=(isset($parmGet['condPagamentoSelected']) ? $parmGet['condPagamentoSelected'] : '');
        $this->situacaoSelecionados=(isset($parmGet['situacaoSelected']) ? $parmGet['situacaoSelected'] : '');
        $this->centroCustoSelecionados=(isset($parmGet['centroCustoSelected']) ? $parmGet['centroCustoSelected'] : '');
        $this->motivoSelecionados=(isset($parmGet['motivoSelected']) ? $parmGet['motivoSelected'] : '');
		        
        $this->m_par = explode("|", $this->m_letra);

        // caminhos absolutos para todos os diretorios biblioteca e sistema
        $this->smarty->assign('pathJs',  ADMhttpBib.'/js');
        $this->smarty->assign('bootstrap', ADMbootstrap);
        $this->smarty->assign('admClass', ADMclass);
        $this->smarty->assign('raizCliente', $this->raizCliente);

        // dados para exportacao e relatorios
        if ($this->m_opcao=="pesquisar"):
            $this->smarty->assign('titulo', "Consulta");
            $this->smarty->assign('colVis', "[ 0,1,2,3,4,5 ]"); 
            $this->smarty->assign('disableSort', "[ 5 ]"); 
            $this->smarty->assign('numLine', "25"); 
        else:
            $this->smarty->assign('titulo', "Consulta");
            $this->smarty->assign('colVis', "[ 0,1,2,3,4,5,6,7,8 ]"); 
            $this->smarty->assign('disableSort', "[ 0 ]"); 
            $this->smarty->assign('numLine', "25"); 
        endif;
    
        
        if($this->m_par[1] == "") $this->smarty->assign('dataIni', date("01/m/Y"));
        else $this->smarty->assign('dataIni', $this->m_par[1]);
    
        if($this->m_par[2] == "") {
            $dia = date("d");
            $mes = date("m");
            $ano = date("Y");
            $data = date("d/m/Y", mktime(0, 0, 0, $mes+1, 0, $ano));
            $this->smarty->assign('dataFim', $data);
        //	$data = mktime(0, 0, 0, $mes, 1, $ano);
        //	$this->smarty->assign('dataFim', date("d",$data-1).date("/m/Y"));
        }
        else $this->smarty->assign('dataFim', $this->m_par[2]);
            
        
        // include do javascript
        // include ADMjs . "/est/s_est.js";
    }

//---------------------------------------------------------------
//---------------------------------------------------------------
    function controle() {
        switch ($this->m_submenu) {
            case 'relatorioVendas':
                $this->geraRelatorioVenda();
            break;
            default:
                    $this->mostraConsulta('');
               
        } //switch
    }

// fim controle
//---------------------------------------------------------------
//---------------------------------------------------------------
    function mostraConsulta($mensagem) {
        $this->smarty->assign('pathCliente', ADMhttpCliente);
        $this->smarty->assign('pathImagem', $this->img);
        $this->smarty->assign('mensagem', $mensagem);
        $this->smarty->assign('letra', $this->m_letra);
        $this->smarty->assign('opcao', $this->m_opcao);
        $this->smarty->assign('subMenu', $this->m_submenu);
        $this->smarty->assign('pesquisa', $this->m_pesq);

        // COMBOBOX SITUACAO
        $sql = "SELECT TIPO AS ID, PADRAO AS DESCRICAO FROM AMB_DDM WHERE (ALIAS='FAT_MENU') AND (CAMPO='SITUACAOPEDIDO') ";
        if (ADMSistema != 'PECAS') {
            $sql .= " AND ((TIPO = 0) or (TIPO = 5) or (TIPO = 6) or (TIPO = 7) or (TIPO = 9) or (TIPO = 10))";
        } 
        // COMBOBOX SITUACAO
        if($this->m_par[4] == "") $this->m_par[4] = '5';

        $this->comboSql($sql, $this->m_par[4], $situacao_id, $situacao_ids, $situacao_names);
        $this->smarty->assign('situacao_ids',   $situacao_ids);
        $this->smarty->assign('situacao_names', $situacao_names);
        $this->smarty->assign('situacao_id',    $situacao_id);
       
        //COMBOBOX Cond Pagamento
        $sql = "SELECT * FROM FAT_COND_PGTO;";
        $this->comboSql($sql, $this->m_par[6], $condPag_id, $condPag_ids, $condPag_names);
        $this->smarty->assign('condPag_id',    $condPag_id);
        $this->smarty->assign('condPag_ids',   $condPag_ids);
        $this->smarty->assign('condPag_names', $condPag_names);

        //COMBOBOX USR Fatura
        $sql = "SELECT USUARIO AS ID, NOME AS DESCRICAO FROM AMB_USUARIO ";
        $this->comboSql($sql, $this->m_par[5], $usrfatura_id, $usrfatura_ids, $usrfatura_names);
        $this->smarty->assign('usrfatura_id',    $usrfatura_id);
        $this->smarty->assign('usrfatura_ids',   $usrfatura_ids);
        $this->smarty->assign('usrfatura_names', $usrfatura_names);     

        // CENTRO DE CUSTO
        $sql = "select CENTROCUSTO AS id, descricao from FIN_CENTRO_CUSTO";
        $this->comboSql($sql, $this->m_empresacentrocusto, $ccusto_id, $ccusto_ids, $ccusto_names);
        $this->smarty->assign('ccusto_id',    $ccusto_id);
        $this->smarty->assign('ccusto_ids',   $ccusto_ids);
        $this->smarty->assign('ccusto_names', $ccusto_names);

        // COMBOBOX MOTIVO
        $sql = "SELECT MOTIVO AS ID, DESCRICAO FROM FAT_MOTIVO";
        $this->comboSql($sql, $this->m_par[8], $motivo_id, $motivo_ids, $motivo_names);
        $this->smarty->assign('motivo_ids',   $motivo_ids);
        $this->smarty->assign('motivo_names', $motivo_names);
        $this->smarty->assign('motivo_id',    $motivo_id);


        $this->smarty->display('rel_pedidos_mostra.tpl');
    }
//---------------------------------------------------------------

// Gera relatório de vendas
//---------------------------------------------------------------
    function geraRelatorioVenda(){
        $this->smarty->assign('dataAtual', strftime('%A, %d de %B de %Y', strtotime('today')));
        $this->smarty->assign('pathImagem', ADMimg);
        $this->smarty->assign('subMenu', $this->m_submenu);
        $this->smarty->assign('letra', $this->m_letra);
        $this->smarty->assign('dataImp', date("d/m/Y H:i:s"));
       
        $lanc = $this->select_pedidos_geral($this->tpRelatorio);

        if ($this->tpRelatorio == 'Detalhado' || $this->tpRelatorio == 'Item' || $this->tpRelatorio == 'Fatura'){
            $lancItem = [];
            
            for ($i=0; $i < count($lanc); $i++){
                $resp = $this->tpRelatorio == 'Fatura' ? 
                        $this->select_fatura_pedidos_venda($lanc[$i]['PEDIDO'])
                        : $this->select_pedidos_item_geral($lanc[$i]['PEDIDO']);

                for($k=0; $k < count($resp); $k++){
                    if($lancItem[0] == ''){
                        $lancItem[$k] = $resp[$k];
                    }else{
                        array_push($lancItem, $resp[$k]);
                    }
                }
            }
        }
        // busca descrição condição pagamento
        if (($lanc[0]['CONDPG'] == '') or ($lanc[0]['CONDPG'] == '0') or ($lanc[0]['CONDPG'] == 0)):
            $descCondPgto = '';
        else:
            $condPgto = new c_cond_pgto();
            $condPgto->setId($lanc[0]['CONDPG']);
            $descPgto = $condPgto->selectCondPgto();
            $descCondPgto = $descPgto[0]['DESCRICAO'];
        endif;

        if ($lanc[0]['SITUACAO'] == 9):
            // Busca lancamentos FINANCEIRO
            $fin = c_lancamento::select_lancamento_doc('PED', $lanc[0]['PEDIDO']);
        else:
            // Calcula lancamentos de acordo com condição pagamento.
            //$fin = c_pedidoVendaNf::calculaParcelasNfe($descCondPgto, $lanc[0]['TOTAL']);
        endif;
        
        
        $this->smarty->assign('descCondPgto', $descCondPgto);
        $this->smarty->assign('pedido', $lanc);
        $this->smarty->assign('pedidoItem', $lancItem);
        $this->smarty->assign('periodoIni', $this->m_par[1]);
        $this->smarty->assign('periodoFim', $this->m_par[2]);
        $this->smarty->assign('fin', $fin);

        $consulta = new c_banco();
        $sql = "SELECT * FROM AMB_USUARIO_AUTORIZA WHERE USUARIO = (".$this->m_usergrupo.") 
                AND PROGRAMA = 'RELPEDIDOVENDACOMCUSTO' AND DIREITOS LIKE '%C%'";
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        if (sizeof($result) > 0){
            $this->smarty->assign('tipoUsuario', 'Consulta');
        }  

        switch ($this->tpRelatorio){
            case 'Mes':
                $this->smarty->display('relatorio_pedido_venda_mes.tpl');
            break;
            case 'Semana':
                $this->smarty->display('relatorio_pedido_venda_semana.tpl');
            break;
            case 'Entregas':
                $this->smarty->display('relatorio_pedido_entrega.tpl');
            break;
            case 'Detalhado':
                $this->smarty->display('relatorio_pedido_venda_detalhado.tpl');
            break;
            case 'Item':
                $this->smarty->display('relatorio_pedido_venda_item.tpl');
            break;
            case 'Fatura':
                $this->smarty->display('relatorio_pedido_venda_fatura.tpl');
            break;
            case 'Vendedor':
                $this->smarty->display('relatorio_pedido_venda_vendedor.tpl');
            break;
            case 'Motivo':
                $this->smarty->display('relatorio_pedido_venda_motivo.tpl');
            break;
            case 'CondPagamento':
                $this->smarty->display('relatorio_pedido_venda_cond_pagamento.tpl');
            break;
            default:
              $this->smarty->display('relatorio_pedido_venda.tpl');
        };


    }// fim geraRelatorioVenda

    function comboSql($sql, $par, &$id, &$ids, &$names) {
        $consulta = new c_banco();
        $consulta->exec_sql($sql);
        $consulta->close_connection();
        $result = $consulta->resultado;
        $ids[0] = '';
        $names[0] = '';
        for ($i = 0; $i < count($result); $i++) {
            $ids[$i+1] = $result[$i]['ID'];
            $names[$i+1] = $result[$i]['DESCRICAO'];
        }
        
        $param = explode(",", $par);
        $i=0;
        $id[$i] = "0";
        while ($param[$i] != '') {
            $id[$i] = $param[$i];
            $i++;
        }    
    }


//fim mostraConsultas
//-------------------------------------------------------------
}

//	END OF THE CLASS
// Rotina principal - cria classe
//$produto = new p_rel_compras(isset($parmPost['id']) ? $parmPost['id'] : '''submenu'], $_POST['letra'], $_POST['quant'], $_POST['acao'], $_REQUEST['pesquisa'], $_POST['opcao'], $_POST['loc'], $_POST['ns'], $_POST['idNF']);
$rel_pedidos = new p_rel_pedidos();

$rel_pedidos->controle();
?>
